/**********************************************************************
 * 
 *  Toby Opferman
 *
 *  Shared Video Memory
 *
 *  This example is for educational purposes only.  I license this source
 *  out for use in learning how to write a device driver.
 *
 *  Copyright (c) 2005, All Rights Reserved  
 **********************************************************************/

#include <windows.h>
#include <stdio.h>
#include "videomemory.h"


/*********************************************************************
 * Internal Prototypes
 *********************************************************************/
PCHAR VideoMemory_AllocateVMWareSharedMemory(UINT uiPid, UINT uiOffset);


/*********************************************************************
 * VideoMemory_GetSharedMemory
 *
 *   This function is used to get shared video memory.
 *
 *********************************************************************/
PCHAR VideoMemory_GetSharedMemory(UINT uiPid, UINT uiOffset)
{
   PCHAR pVideoMemory;

   pVideoMemory = VideoMemory_AllocateVMWareSharedMemory(uiPid, uiOffset);
   
   return pVideoMemory;
}


/*********************************************************************
 * VideoMemory_AllocateVMWareSharedMemory
 *
 *   This function is used to return a shared memory region between
 *   Guest and Host OS using VMWare.
 *
 *********************************************************************/
PCHAR VideoMemory_AllocateVMWareSharedMemory(UINT uiPid, UINT uiOffset)
{
    PCHAR pVideoMemory = NULL;
    HANDLE hMapFile;    
    char szName[256];

    sprintf(szName, "VMwareMem%iMemory", uiPid);
    
    hMapFile = OpenFileMapping(PAGE_READWRITE, FALSE, szName);
    
    pVideoMemory =  MapViewOfFile(hMapFile, FILE_MAP_READ, 0, 0, 0);

    pVideoMemory += uiOffset;


    return pVideoMemory;
}


